import { Injectable, NgModule, Directive, forwardRef, Input, defineInjectable } from '@angular/core';
import { NG_VALIDATORS, FormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DtCompareEqualValidatorService {
    constructor() { }
}
DtCompareEqualValidatorService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
DtCompareEqualValidatorService.ctorParameters = () => [];
/** @nocollapse */ DtCompareEqualValidatorService.ngInjectableDef = defineInjectable({ factory: function DtCompareEqualValidatorService_Factory() { return new DtCompareEqualValidatorService(); }, token: DtCompareEqualValidatorService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} controlName
 * @return {?}
 */
function compareEqual(controlName) {
    return (/**
     * @param {?} control
     * @return {?}
     */
    (control) => {
        if (!control.parent || control.parent.get(controlName).value === control.value) {
            return null;
        }
        else {
            return { compareEqual: true };
        }
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const COMPARE_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef((/**
     * @return {?}
     */
    () => CompareEqualDirective)),
    multi: true
};
class CompareEqualDirective {
    constructor() { }
    /**
     * @param {?} control
     * @return {?}
     */
    validate(control) {
        return compareEqual(this.dtCompareEqual)(control);
    }
}
CompareEqualDirective.decorators = [
    { type: Directive, args: [{
                selector: '[dtCompareEqual]',
                providers: [COMPARE_EQUAL_VALIDATOR]
            },] }
];
/** @nocollapse */
CompareEqualDirective.ctorParameters = () => [];
CompareEqualDirective.propDecorators = {
    dtCompareEqual: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DtCompareEqualValidatorModule {
}
DtCompareEqualValidatorModule.decorators = [
    { type: NgModule, args: [{
                declarations: [CompareEqualDirective],
                imports: [
                    FormsModule
                ],
                exports: [CompareEqualDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DtCompareEqualValidatorService, DtCompareEqualValidatorModule, compareEqual, CompareEqualDirective };

//# sourceMappingURL=dt-compare-equal-validator.js.map